package it.unibo.sdls.sampleproject.dao.ejb3;

import it.unibo.sdls.sampleproject.dao.Author;
import it.unibo.sdls.sampleproject.dao.AuthorDAO;

import java.util.Iterator;
import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Transient;
@Stateless @TransactionManagement(TransactionManagementType.CONTAINER)
public class AuthorDAOBean implements AuthorDAO {


	@PersistenceContext(unitName = "SampleProjectUnit") EntityManager em;
	
	
	public int insertAuthor(Author author) {
		em.persist(author);
		return 0;
	}

	@SuppressWarnings("unchecked")
	private List<Author> findByName(String name)
	{
		return em.createQuery("SELECT a FROM Author a WHERE name LIKE :n ")
		.setParameter("n", name)
		.getResultList();
	}
	
	public int removeAuthorByName(String name) {
		List<Author> l=findByName(name);
		Iterator<Author> i=l.iterator();
		while(i.hasNext())
		{
			em.remove((Author)i.next());
		}
		return 0;
	}

	public int removeAuthorById(int id) {
		Author a=em.find(Author.class, id);
		em.remove(a);
		return 0;
	}

	public Author findAuthorByName(String name) {
		findByName(name).get(0);
		return null;
	}

	public Author findAuthorById(int id) {
		return em.find(Author.class, id);
	}

	@SuppressWarnings("unchecked")
	public List<Author> findAllAuthors() {
		return em.createQuery("SELECT a FROM Author a" ).getResultList();
	}

}
