package it.unibo.sdls.sampleproject.dao.ejb3;

import it.unibo.sdls.sampleproject.dao.Publisher;
import it.unibo.sdls.sampleproject.dao.PublisherDAO;

import java.util.Iterator;
import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;

import com.sun.corba.se.spi.legacy.connection.GetEndPointInfoAgainException;
@Stateless @TransactionManagement(TransactionManagementType.CONTAINER)

public class PublisherDAOBean implements PublisherDAO {

	@PersistenceContext(unitName = "SampleProjectUnit")EntityManager em;
	
	@SuppressWarnings("unchecked")
	private List<Publisher> findByName(String name)
	{
		return em.createQuery("SELECT a FROM Publisher a WHERE name LIKE :n ")
		.setParameter("n", name)
		.getResultList();
	}
	
	public int insertPublisher(Publisher publisher) {
		em.persist(publisher);
		return 0;
	}

	public Publisher findPublisherByName(String name) {
		return findByName(name).get(0);
	}

	public Publisher findPublisherById(int id) {
	   return em.find(Publisher.class, id);
	}

	@SuppressWarnings("unchecked")
	public List<Publisher> findAllPublishers() {
		return em.createQuery("SELECT a FROM Publisher a" ).getResultList();
	}

	public int removePublisherByName(String name) {
		List<Publisher> l=findByName(name);
		Iterator<Publisher> i=l.iterator();
		while(i.hasNext())
		{
			em.remove((Publisher)i.next());
		}
		return 0;
	}

	public int removePublisherById(int id) {
		em.remove(em.find(Publisher.class, id));
		return 0;
	}

}
